package main

import (
	cfg2 "cicv-data-closedloop/kinglong/common/cfg"
	commonInit "cicv-data-closedloop/kinglong/common/init"
	svc3 "cicv-data-closedloop/kinglong/common/svc"
	slaveConfig "cicv-data-closedloop/kinglong/slave/pkg/cfg"
	svc4 "cicv-data-closedloop/kinglong/slave/pkg/svc"
)

// init 初始化函数
func init() {
	//runtime.GOMAXPROCS(1)
	commonInit.Init()
	slaveConfig.InitTcpListener()
	cfg2.InitKillSignalListener(cfg2.CloudConfig.Hosts[1].Ip)
	// 等待重启，接收到重启信号，会把信号分发给以下channel
	go svc3.WaitKillSelf()
}

// main 主函数
func main() {

	// 1 负责打包数据到data目录
	go svc3.BagRecord(cfg2.CloudConfig.Hosts[1].Name)
	// 2 负责监控故障，并修改timeWindow
	go svc4.PrepareTimeWindowProducerQueue()
	// 3
	go svc4.RunTimeWindowProducerQueue()
	// 4 排队运行时间窗口
	go svc3.RunTimeWindowConsumerQueue(cfg2.CloudConfig.Hosts[1].Name)

	// 阻塞主线程，等待其他线程执行。
	select {}

}
